const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const customers = sequelize.define(
    'customers',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

first_name: {
        type: DataTypes.TEXT,
      
      

      },

last_name: {
        type: DataTypes.TEXT,
      
      

      },

email: {
        type: DataTypes.TEXT,
      
      

      },

phone: {
        type: DataTypes.TEXT,
      
      

      },

customer_state: {
        type: DataTypes.ENUM,
      
      

        values: [

"enabled",


"disabled",


"invited",


"declined"

        ],

      },

created_on_shopify_at: {
        type: DataTypes.DATE,
      
      

      },

orders_count: {
        type: DataTypes.INTEGER,
      
      

      },

total_spent: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  customers.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












    db.customers.hasMany(db.addresses, {
      as: 'addresses_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });


    db.customers.hasMany(db.orders, {
      as: 'orders_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });










    db.customers.hasMany(db.chat_sessions, {
      as: 'chat_sessions_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });



    db.customers.hasMany(db.support_tickets, {
      as: 'support_tickets_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });




//end loop



    db.customers.belongsTo(db.stores, {
      as: 'store',
      foreignKey: {
        name: 'storeId',
      },
      constraints: false,
    });

    db.customers.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.customers.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.customers.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return customers;
};


